#include <windows.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>


#include <GL/GL.h>
#include <GL/glut.h>

#include "RGBpixmap.h"





//Set windows
int screenWidth = 800 , screenHeight = 600;

int i=0;
RGBpixmap pic[3]; // create two (empty) global pixmaps
RGBpixmap bg;
int whichPic = 0; // which pixmap to display
int picX=0, picY=0;


int jumpState=0;
int DirectState=0;  //0:right  1:left
int Gamescore=0;

void init();

//<<<<<<<<<<<<<<<<<<<<<<<<< myMouse >>>>>>>>>>>>>>>>>>>>>>>>
/*void myMouse(int button, int state, int mx, int my)
{ // set raster position with a left click
	if(button == GLUT_LEFT_BUTTON )
	{


		glutPostRedisplay();
	}

}*/
//<<<<<<<<<<<<<<<<<<<<<<<<< mouseMove >>>>>>>>>>>>>>>>>
/*void mouseMove(int x, int y)
{// set raster position with mouse motion
	//rasterPos.x = x; rasterPos.y = screenHeight - y;
	//glRasterPos2i(rasterPos.x, rasterPos.y);
	glutPostRedisplay();
}*/
//myReshape
void myReshape(int w, int h)
{
    /* Save the new width and height */
    screenWidth  = w;
    screenHeight = h;

    /* Reset the viewport... */
    glViewport(0, 0, screenWidth, screenHeight);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, (GLfloat)screenWidth, 0.0, (GLfloat)screenHeight, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);

}

bool process()
{
    unsigned char tempr, tempg, tempb;
    mRGB tempcolor;

    for(int y=0; y<pic[1].nRows; y++) {
        for(int x=0; x<pic[1].nCols; x++) {

            if(y<0.5*pic[1].nRows) {
                tempcolor = pic[0].getPixel(x, y);
                pic[1].setPixel(x, y, tempcolor);
            } else {
                tempcolor.set(255, 0, 0);
                pic[1].setPixel(x, y, tempcolor);
            }
        }
    }

	return true;
}


//myDisplay
void myDisplay(void)
{
	glClear(GL_COLOR_BUFFER_BIT);

    glRasterPos2i(picX, picY);
    pic[0].draw();

    //do some image process
    process();

    //draw traget image
    glRasterPos2i(picX+pic[1].nCols+20, picY);
    pic[1].draw();

    //Font
	char mss[30], mss2[30];
	sprintf(mss, "Source");
	sprintf(mss2, "target");

	glColor3f(1.0, 0.0, 0.0);  //set font color
    glRasterPos2i(10, screenHeight-20);    //set font start position
	void * font = GLUT_BITMAP_9_BY_15;
	for(int i=0; i<strlen(mss); i++) {
		glutBitmapCharacter(font, mss[i]);
	}

    glRasterPos2i(picX+pic[1].nCols+20+10, screenHeight-20);    //set font start position
	//void * font = GLUT_BITMAP_9_BY_15;
	for(int i=0; i<strlen(mss); i++) {
		glutBitmapCharacter(font, mss2[i]);
	}

	glutSwapBuffers();
}



void SpecialKeys(int key, int x, int y)
{
	// this string keeps the last good setting for the game mode
    char gameModeString[40] = "640x480";

	switch(key) {
 /*	case GLUT_KEY_UP:
			picY += 5;
			break;
		case GLUT_KEY_DOWN:
			picY -= 5;
			break;*/
		case GLUT_KEY_LEFT:
			picX -= 5;
			if (whichPic==0) whichPic=1;
			else whichPic=0;
			DirectState=1;
			break;
		case GLUT_KEY_RIGHT:
			picX += 5;
			if (whichPic==0) whichPic=1;
			else whichPic=0;
			DirectState=0;
			break;

	    /**case GLUT_KEY_F1:
			// define resolution, color depth
			glutGameModeString("640x480:32");
			// enter full screen
			if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
				glutEnterGameMode();
				sprintf(gameModeString,"640x480:32");
				// register callbacks again
				// and init OpenGL context
				init();
			}
			else
				glutGameModeString(gameModeString);
			break;

	    case GLUT_KEY_F2:
			glutFullScreen();
			break;
		case GLUT_KEY_F6:
			// return to default window
			if (glutGameModeGet(GLUT_GAME_MODE_ACTIVE) != 0)
				glutLeaveGameMode();
			break;*/

	}
	glutPostRedisplay();
}







//<<<<<<<<<<<<<<<<<<<<<<<< myKeys >>>>>>>>>>>>>>>>>>>>>>
void myKeys(unsigned char key, int x, int y)
{
	switch(key)
	{

        case 'Q':
        case 'q':
			exit(0);
			break;

        /*case 'b':
			bf(0);
			break;*/

	}
	glutPostRedisplay();
}


void init()
{
	glutSpecialFunc(SpecialKeys);
	glutKeyboardFunc(myKeys);
//	glutMouseFunc(myMouse);
//	glutMotionFunc(mouseMove);
	glutDisplayFunc(myDisplay);
	glutReshapeFunc(myReshape);

    glClearColor(1.0f, 1.0f, 1.0f, 0.0f); //background color(1.0, 1.0, 1.0): white color
}

int main(int argc, char **argv)
{
	cout<<"Reading images";
	//input image
    pic[0].readBMPFile("image/input_small.bmp");  cout<<'.';
	pic[1].readBMPFile("image/input_small.bmp");  cout<<'.';
    //pic[2].readBMPFile("image/fly.bmp");  cout<<'.'<<endl;

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);

    screenWidth = pic[0].nCols *2 +20;
    screenHeight = pic[0].nRows + 20;
	glutInitWindowSize(screenWidth, screenHeight);
	glutInitWindowPosition(50, 30);
	glutCreateWindow("Image Morphing");

	init();

	srand(time(0));  //rand seed



	//for (int i=0; i<3; i++) pic[i].setChromaKey(232, 248, 248);

	//cout<<"Reading Backgroud........"<<endl;
	//bg.readBMPFile("image/dog.bmp");

	glutMainLoop();

	return 0;
}

